<?php

namespace App\Policies;

use App\Models\RequestInfoSubmission;
use App\Models\User;
use Illuminate\Auth\Access\Response;

class RequestInfoSubmissionPolicy
{
    /**
     * Determine whether the user can view any models.
     */
    public function viewAny(User $user): bool
    {
        return $user->hasAnyPermission([
            'create requestinfosubmission', 'edit requestinfosubmission', 'view requestinfosubmission', 'delete requestinfosubmission'
        ]);
    }

    /**
     * Determine whether the user can view the model.
     */
    public function view(User $user, RequestInfoSubmission $requestInfoSubmission): bool
    {
        return $user->hasPermissionTo('view requestinfosubmission');
    }

    /**
     * Determine whether the user can create models.
     */
    public function create(User $user): bool
    {
        return $user->hasPermissionTo('create requestinfosubmission');
    }

    /**
     * Determine whether the user can update the model.
     */
    public function update(User $user, RequestInfoSubmission $requestInfoSubmission): bool
    {
        return $user->hasPermissionTo('edit requestinfosubmission');
    }

    /**
     * Determine whether the user can delete the model.
     */
    public function delete(User $user, RequestInfoSubmission $requestInfoSubmission): bool
    {
        return $user->hasPermissionTo('delete requestinfosubmission');
    }

    /**
     * Determine whether the user can restore the model.
     */
    public function restore(User $user, RequestInfoSubmission $requestInfoSubmission): bool
    {
        return $user->hasPermissionTo('restore requestinfosubmission');
    }

    /**
     * Determine whether the user can permanently delete the model.
     */
    public function forceDelete(User $user, RequestInfoSubmission $requestInfoSubmission): bool
    {
        return $user->hasPermissionTo('force delete requestinfosubmission');
    }
}
